Unit Hrac3;

interface

  uses dat_typy;

  function inicializujSa(cisloHraca:byte):string;
  procedure tahaj(var panaci:typePanaci; ihrisko:typeIhrisko);
  procedure hlaska(var subor,text:string);

implementation

  uses crt;

  const
    ss:array[1..4,1..2] of integer=((0,-1),(1,0),(0,1),(-1,0));
    sh:integer=0;

  var
    suborincek,zahlas:string;
    tah:integer;
    priorita:integer;
    lastpocn:integer;
    mojeCislo:byte;
    c,ma:array[1..celkovypocetpanakov+velkostihriska] of integer;
    pocetn,ft,idu,pocn,gre,ns:integer;
    tarx,tary,tx,ty:integer;

    pp:typepanaci;
    ii:typeihrisko;

function okolon(x,y:integer):boolean;
var
  s,g:integer;
begin
  s:=0;
  g:=6; if mojecislo+5=g then inc(g);
  if (x>1) and (ii[x-1,y]=g) then inc(s);
  if (y>1) and (ii[x,y-1]=g) then inc(s);
  if (x<velkostihriska) and (ii[x+1,y]=g) then inc(s);
  if (y<velkostihriska) and (ii[x,y+1]=g) then inc(s);
  if s<2 then okolon:=false else begin okolon:=true; exit; end;
  s:=0;
  inc(g); if mojecislo+5=g then inc(g);
  if (x>1) and (ii[x-1,y]=g) then inc(s);
  if (y>1) and (ii[x,y-1]=g) then inc(s);
  if (x<velkostihriska) and (ii[x+1,y]=g) then inc(s);
  if (y<velkostihriska) and (ii[x,y+1]=g) then inc(s);
  if s<2 then okolon:=false else begin okolon:=true; exit; end;
  s:=0;
  inc(g); if mojecislo+5=g then inc(g);
  if (x>1) and (ii[x-1,y]=g) then inc(s);
  if (y>1) and (ii[x,y-1]=g) then inc(s);
  if (x<velkostihriska) and (ii[x+1,y]=g) then inc(s);
  if (y<velkostihriska) and (ii[x,y+1]=g) then inc(s);
  if s<2 then okolon:=false else begin okolon:=true; exit; end;
end;

  procedure hlas(sub,co:string;prior:integer);
  begin
     if prior>=priorita then zahlas:=co;
     if prior>=priorita then suborincek:=sub;
     if prior>=priorita then priorita:=prior;
  end;

  function inicializujSa(cisloHraca:byte):string;
    begin
      lastpocn:=pocetpanakov;
      fillchar(c,sizeof(c),0);
      ft:=0; ns:=0;
      mojeCislo := cisloHraca;
      inicializujSa := 'PAPajka';
      tah:=0;
      gre:=0;
    end;

  function free(x,y:integer):boolean;
  begin
    if (x<1) or (x>32) or (y<1) or (y>32) then free:=false else begin
      if ii[x,y]<6 then begin
        if not okolon(x,y) then free:=true else free:=false;
      end else free:=false;
    end;
  end;

  function sgn(a:integer):integer;
  begin
    if a>0 then sgn:=1 else begin
      if a<0 then sgn:=-1 else sgn:=0;
    end;
  end;

function ide(i,x,y:integer):boolean;
var
  sx,sy:integer;
begin
  if i>celkovypocetpanakov then exit;
  if (x=pp[i].x) and (y=pp[i].y) then begin ide:=true; inc(idu); exit; end;
  ide:=false;
  sx:=x-pp[i].x; sy:=y-pp[i].y;
  if abs(sx)>abs(sy) then begin
    if sx>0 then pp[i].smer:=2 else pp[i].smer:=4;
    inc(idu);
    if not free(pp[i].x+sgn(sx),pp[i].y) then begin
      if sy>0 then pp[i].smer:=3 else pp[i].smer:=1;
      if not free(pp[i].x,pp[i].y+sgn(sy)) then begin
        pp[i].smer:=random(4)+1; dec(idu);
      end;
    end;

  end else begin
    if sy>0 then pp[i].smer:=3 else pp[i].smer:=1;
    inc(idu);
    if not free(pp[i].x,pp[i].y+sgn(sy)) then begin
      if sx>0 then pp[i].smer:=2 else pp[i].smer:=4;
      if not free(pp[i].x+sgn(sx),pp[i].y) then begin
        pp[i].smer:=random(4)+1; dec(idu);
      end;
    end;
  end;
end;

procedure taz;
var
  x,y:longint;
  m:integer;
begin
  x:=0; y:=0; pocetn:=0;
  for m:=1 to celkovypocetpanakov do begin
    if pp[m].koho=mojecislo then begin x:=x+pp[m].x; y:=y+pp[m].y;inc(pocetn); end;
  end;
  if pocetn=0 then pocetn:=1;
  tx:=round(x/pocetn); ty:=round(y/pocetn);
end;

procedure tar;
var
  a,b,c:integer;
  f:longint;
begin
  f:=-1; pocn:=0;
  for a:=1 to celkovypocetpanakov do begin
    if pp[a].koho<>mojecislo then begin
      inc(pocn);
      if f=-1 then begin tarx:=pp[a].x; tary:=pp[a].y;
        f:=sqr(pp[a].x-tx)+sqr(pp[a].y-ty);
      end else begin
        if f>(sqr(pp[a].x-tx)+sqr(pp[a].y-ty)) then begin
          tarx:=pp[a].x; tary:=pp[a].y;
          f:=sqr(pp[a].x-tx)+sqr(pp[a].y-ty);
        end;
      end;
    end;
  end;
end;

procedure att;
var
  i:integer;
begin
  for i:=1 to celkovypocetpanakov do begin
    if pp[i].koho=mojecislo then begin
       ide(i,tarx,tary);
    end;
  end;
end;

function min(a,b:integer):integer;
begin
   if a<b then min:=a else min:=b;
end;

procedure formacja;
var
  x,a,b:integer;
begin
  if celkovypocetpanakov<velkostihriska then inc(sh);
  for x:=1 to velkostihriska do begin
    if x<=celkovypocetpanakov then begin
      if (pp[ma[x]].y=1) then begin
        c[x]:=1;
      end;
      if (pp[ma[x]].y=velkostihriska) then begin
        c[x]:=0;
      end;
      if c[x]=0 then ide(ma[x],x+(sh div 5),1) else ide(ma[x],x+(sh div 5),velkostihriska);
    end;
  end;
  for x:=velkostihriska+1 to celkovypocetpanakov do begin
    if c[1]=0 then ide(ma[x],velkostihriska,velkostihriska) else
      ide(ma[x],velkostihriska,1);
  end;
  if sh>5*(velkostihriska-celkovypocetpanakov-pocn) then sh:=0;
end;

procedure okolo(x,y:integer);
var
  s:integer;
begin
  s:=0;
  if (x>1) and (ii[x-1,y]=mojecislo+5) then inc(s);
  if (y>1) and (ii[x,y-1]=mojecislo+5) then inc(s);
  if (x<velkostihriska) and (ii[x+1,y]=mojecislo+5) then inc(s);
  if (y<velkostihriska) and (ii[x,y+1]=mojecislo+5) then inc(s);
  if s>1 then begin
    for s:=1 to celkovypocetpanakov do begin
      if pp[s].koho=mojecislo then begin
        if (abs(pp[s].x-x)<2) and (abs(pp[s].y-y)<2) then pp[s].smer:=0;
      end;
    end;
  end;
end;

procedure neutec;
var
  x:integer;
  b:integer;
begin
  for x:=1 to celkovypocetpanakov do begin
    if pp[x].koho<>mojecislo then begin
      okolo(pp[x].x,pp[x].y);
    end;
  end;
end;

  procedure tahaj(var panaci:typePanaci; ihrisko:typeIhrisko);
    var i:byte;
        x,y,z:integer;
    begin
    inc(tah);
    priorita:=0;
    hlas('','',0);
    pp:=panaci; ii:=ihrisko;
    case gre of
      0:begin
          taz;
          tar;
          att;
          neutec;
          if (pocn=0) or (tah+30>pocet_tahov) then gre:=1;
       end;
      1:begin
          x:=1;
          for i:=1 to celkovypocetpanakov do begin
            if pp[i].koho=mojecislo then begin ma[x]:=i; inc(x); end;
          end;
          for i:=x to celkovypocetpanakov do ma[i]:=1;
          formacja;
        end;
      end;
      if pocn>lastpocn then case random(8) of
         0:hlas('KRVYKRIK.WAV','Do kelu',20);
         1:hlas('KROOPS.WAV','Oooops',20);
         2:hlas('KRVYKRIK.WAV','Ou shit',20);
         3:hlas('KRJUJ.WAV','J U J !',20);
      end;
      if pocn<lastpocn then case random(4) of
         0:hlas('KRPOMAL2.WAV','Pomaly zhnijete',10);
         1:hlas('KRKDE_JE.WAV','Kde je ten zkrachovany chudacik?',10);
      end;
      if pocn=celkovypocetpanakov then case random(12) of
         0:hlas('KRPOMALY.WAV','Pomaly hnijeme',5);
         1:hlas('KRNO_ZAU.WAV','No zautocte vy ciciaci !!! :-))) ',5);
      end;
      if pocn<3 then case random(12) of
         0:hlas('KRPOMAL2.WAV','Pomaly hnijete',4);
         1:hlas('KRPAPLUH.WAV','P A P L U H   i s   B E S T !',4);
      end;
      lastpocn:=pocn;
      if gre=1 then case random(18) of
         0:hlas('KRBU_BU_','Bu bu bu Fantomas coming...',9);
         1:hlas('KRPAPLUH.WAV','P A P L U H   I S   B E S T !',9);
      end;
      z:=0;
      if gre=1 then for x:=1 to velkostihriska do
                       for y:=1 to velkostihriska do
                          if not ihrisko[x,y] in [mojecislo,mojecislo+5] then inc(z);
      if gre=1 then if z=1 then case random(2) of
         0:hlas('KRPAPLUH.WAV','Papluh is D best !',50);
         1:hlas('KRPROF.WAV','Profesionalita sa pozn !',50);
      end;
      case pocn of
         1..5:case random(90) of
            0:hlas('KRKDE_JE.WAV','Kde je ten skrachovany chudacik?',15);
            1:hlas('KRNA_PI_.WAV','N, py pi py py...',15);
            2:hlas('KRAJ_TAK.WAV','Aj tak ta dostanem :-)))) ',15);
            3:hlas('KRTO_TI_.WAV','To ti nevyjde, BATMANE !',15);
            4:hlas('KRBU_BU_.WAV','BU BU BU ! IDE Fantomas',15);
            5:hlas('KRPOMAL2.WAV','Pomaly zhnijete ! TUC-TUC-TUC',15);
         end;
      end;
      panaci:=pp;
    end;

  procedure hlaska(var subor,text:string);
    begin
      if random(3)=0 then begin subor:=suborincek; text:=zahlas end else
      begin subor:=''; text:=''; end;
      if (tah<pocet_tahov-100) and ((random(1000)=314)) then if zahlas='' then begin
         subor:='KRUVAHA.WAV';
         text:='THINKING ...';
      end;
      if (Tah=pocet_tahov) and (pocn<celkovypocetpanakov div 8) then begin
         subor:='KRPROF.WAV';
         text:='Profesionalita sa pozn !';
      end;
    end;
end.
