const
   farbaPozadia = 7;
   farbaTiena = 8;

var
   oknorozdiel, vypisxmedzera,
   oknox1, oknoy1, oknox2, oknoy2,
   vypisx1, vypisy1, vypisx2, vypisy2,
   infox1, infoy1, infox2, infoy2,
   tahyx1, tahyy1, tahyx2, tahyy2,
   polickosizex, polickosizey:integer;

   vyskaFontu:integer;
   infax1,infay1,infax2,infay2:array[1..5] of integer;

procedure okno(x1,y1,x2,y2:integer); forward;

procedure initOkna; {lokalna procedura}
begin
   oknorozdiel := 2;
   oknox1 := oknorozdiel;
   oknoy1 := oknorozdiel;
   oknox2 := 499;
   oknoy2 := GetMaxY * 4 div 5;
   vypisx1 := oknorozdiel;
   vypisy1 := oknoy2 + oknorozdiel + 1;
   vypisx2 := oknox2;
   vypisy2 := GetMaxY - oknorozdiel;
   infox1 := oknox2 + oknorozdiel + 1;
   infoy1 := oknoy1;
   infox2 := GetMaxX - oknorozdiel;
   infoy2 := GetMaxY * 6 div 7;
   tahyx1 := infox1;
   tahyy1 := infoy2 + oknorozdiel + 1;
   tahyx2 := infox2;
   tahyy2 := vypisy2;
   vypisxmedzera := 7;
   polickosizex := (oknox2-oknox1) div velkostIhriska;
   polickosizey := (oknoy2-oknoy1) div velkostIhriska;
end;

procedure initGrafika(pocetHracov:integer);
var gd,gm:integer;
    i:integer;
begin
   DetectGraph(gd,gm);
{$IFDEF EGA}
   gd:=EGA; gm:=1;
{$ENDIF}
   Initgraph(gd,gm,'.');

   initOkna;

   setBkColor(farbaPozadia);
   okno(vypisx1,vypisy1,vypisx2,vypisy2);
   okno(oknox1,oknoy1,oknox2,oknoy2);
   okno(tahyx1,tahyy1,tahyx2,tahyy2);
   for i:=1 to pocetHracov do
   begin
      infax1[i] := infox1;
      infay1[i] := infoy1 + (i-1) * ((infoy2-infoy1) div pocetHracov);
      infax2[i] := infox2;
      infay2[i] := infay1[i] + ((infoy2-infoy1) div pocetHracov) -
         oknorozdiel - 1;
      if (i = pocetHracov) then infay2[i] := infoy2;
      okno(infax1[i],infay1[i],infax2[i],infay2[i]);
   end;
   SetTextStyle(TriplexFont, HorizDir, 4);
   vyskaFontu := TextHeight('H') + 1; {akoze najvyssie pismeno}
end;

procedure closeGrafika;
begin
   CloseGraph;
end;

procedure okno(x1,y1,x2,y2:integer);
begin
   setcolor(15);
   line(x1,y1,x2-1,y1);       {hore}
   line(x1,y1+1,x1,y2-1);     {vlavo}
   setcolor(8);
   line(x1+1,y2,x2,y2);       {dole}
   line(x2,y1+1,x2,y2-1);     {vpravo}
end;

procedure scrollUp(x1,y1,x2,y2,kolko:integer);
var bitmap:pointer;
    i:integer;
begin
   getmem(bitmap,imagesize(x1,y1+kolko,x2,y2));
   getimage(x1,y1+kolko,x2,y2,bitmap^);
   putimage(x1,y1,bitmap^,normalput);
   freemem(bitmap,imagesize(x1,y1+kolko,x2,y2));
   SetFillStyle(1,farbaPozadia);
   bar(x1,y2-kolko+1,x2,y2);
end;

procedure vypis(co:string; farba:byte);
var i,stlpec:integer;
begin
   SetTextJustify(LeftText,TopText);
   scrollUp(vypisx1+2,vypisy1+3,vypisx2-2,vypisy2-2,vyskaFontu);
   i:=1; stlpec:=vypisxmedzera; {zaciname kreslit na sedmicke}
   while (i <= length(co)) do
   begin
      if (vypisx1+stlpec+TextWidth(co[i]) > vypisx2-vypisxmedzera) then
      begin {vytieklo by pismeno}
         stlpec:=vypisxmedzera;
         while ((i <= length(co)) and (co[i] = ' ')) do inc(i);
         if (i <= length(co)) then
            scrollUp(vypisx1+2,vypisy1+3,vypisx2-2,vypisy2-2,vyskaFontu);
      end;
      if (i <= length(co)) then
      begin
         setcolor(farbaTiena);
         outtextxy(vypisx1+stlpec+1,vypisy2+1 - (3 * vyskaFontu div 2),co[i]);
         setcolor(farba);
         outtextxy(vypisx1+stlpec,vypisy2 - (3 * vyskaFontu div 2),co[i]);
         inc(stlpec,TextWidth(co[i]));
         inc(i);
      end;
   end;
end;

procedure vypisMena;
var i:byte;
begin
   SetTextJustify(LeftText,TopText);
   SetFillStyle(1,farbaPozadia);
   for i:=1 to POCET_HRACOV do
   begin
      while (TextWidth(hrac[i].meno) >= infax2[i]-infax1[i]-8) do
         hrac[i].meno := copy(hrac[i].meno,1,length(hrac[i].meno)-1);

      bar(infax1[i]+2,infay1[i]+2,infax2[i]-2,infay2[i]-2);
      setColor(farbaTiena);
      outtextxy(infax1[i] + vypisxmedzera+1,infay1[i] + 1, hrac[i].meno);
      setColor(hrac[i].farba);
      outtextxy(infax1[i] + vypisxmedzera,infay1[i], hrac[i].meno);
   end;
end;

procedure vypisBody(ktoc:integer);
var s:string;
begin
   SetTextJustify(RightText,TopText);
   SetFillStyle(1,farbaPozadia);
   bar(infax1[ktoc]+2,infay1[ktoc] + 4 + TextHeight('H'),
      infax2[ktoc]-2,infay2[ktoc]-2);

   str(hrac[ktoc].body,s);
   setColor(farbaTiena);
   outtextxy(infax2[ktoc] - vypisxmedzera+1,
      infay1[ktoc] + 1 + TextHeight('H'), s);
   setColor(hrac[ktoc].farba);
   outtextxy(infax2[ktoc] - vypisxmedzera,
      infay1[ktoc] + TextHeight('H'), s);
{$IFNDEF EGA}
   str(hrac[ktoc].bodyHlasok,s);
   setColor(farbaTiena);
   outtextxy(infax2[ktoc] - vypisxmedzera+1,
      infay1[ktoc] + 1 + 2*TextHeight('H'), s);
   setColor(hrac[ktoc].farba);
   outtextxy(infax2[ktoc] - vypisxmedzera,
      infay1[ktoc] + 2*TextHeight('H'), s);
{$ELSE}
   SetTextJustify(LeftText,TopText);
   str(hrac[ktoc].bodyHlasok,s);
   setColor(farbaTiena);
   outtextxy(infax1[ktoc] + vypisxmedzera+1,
      infay1[ktoc] + 1 + TextHeight('H'), s);
   setColor(hrac[ktoc].farba);
   outtextxy(infax1[ktoc] + vypisxmedzera,
      infay1[ktoc] + TextHeight('H'), s);
{$ENDIF}
end;

procedure vypisTahy(tah:integer);
var s:string;
begin
   SetTextJustify(CenterText,CenterText);
   SetFillStyle(1,farbaPozadia);
   bar(tahyx1+2,tahyy1+2,tahyx2-2,tahyy2-2);

   str(tah,s);
   setColor(farbaTiena);
   outtextxy(1+(tahyx1+tahyx2) div 2, 1+(tahyy1+tahyy2) div 2, s);
   setColor(arbiterFarba);
   outtextxy((tahyx1+tahyx2) div 2, (tahyy1+tahyy2) div 2, s);
end;

procedure kresliPolicko(x,y:byte);
var x1,y1:integer;
    farba:byte;
begin
   x1 := ((oknox1+oknox2) - (velkostIhriska*polickosizex)) div 2;
   y1 := ((oknoy1+oknoy2) - (velkostIhriska*polickosizey)) div 2;

   farba:=ihrisko[x,y];
   if (farba = 0) then farba := 0
   else begin
      if (farba > panakC) then
      begin
         dec(farba,panakC);
         farba:=hrac[farba].farba;
      end else begin
         dec(farba,vlastniC);
         farba:=hrac[farba].farbaVlastni;
      end;
   end;
   SetFillStyle(1,farba);
   bar(
      x1+2+((x-1)*polickosizex),
      y1+2+((y-1)*polickosizey),
      x1+(x*polickosizex)-1,
      y1+(y*polickosizey)-1
   );
end;

procedure kresliIhrisko;
var i,j,x1,y1:integer;
begin
   x1 := ((oknox1+oknox2) - (velkostIhriska*polickosizex)) div 2;
   y1 := ((oknoy1+oknoy2) - (velkostIhriska*polickosizey)) div 2;
   for i:=1 to velkostIhriska do
      for j:=1 to velkostIhriska do
      begin
         okno(
            x1+1+((i-1)*polickosizex),
            y1+1+((j-1)*polickosizey),
            x1+(i*polickosizex),
            y1+(j*polickosizey)
         );
         kresliPolicko(i,j);
      end;
end;
