Unit Hrac2;

interface

  uses dat_typy;

  function inicializujSa(cisloHraca:byte):string;
  procedure tahaj(var panaci:typePanaci; ihrisko:typeIhrisko);
  procedure hlaska(var subor,text:string);

implementation

  uses crt;

  var mojeCislo:byte;
      pole_mojich:array[1..40] of shortint;
      p:^typepanaci;
      m:^typeIhrisko;
      x:byte;

function inicializujSa(cisloHraca:byte):string;
var i: byte;
begin
 mojeCislo := cisloHraca;
 inicializujSa := 'CPU';
 for i:=1 to 40 do pole_mojich[i]:=0;
end;

Function V_smere(smer,i:byte):boolean;
begin
 v_smere:=false;
 if (smer=hore) or (smer=dole) then begin
  if smer=hore then if m^[p^[i].x,p^[i].y-1]=mojecislo+5 then v_smere:=true;
  if smer=dole then if m^[p^[i].x,p^[i].y+1]=mojecislo+5 then v_smere:=true;
 end else begin
  if smer=vlavo then if m^[p^[i].x-1,p^[i].y]=mojecislo+5 then v_smere:=true;
  if smer=vpravo then if m^[p^[i].x+1,p^[i].y]=mojecislo+5 then v_smere:=true;
 end;
end;


Function Pocet_Nepriatelov:byte;
var i,x:integer;
begin
 x:=0;
 for i:=1 to 40 do if p^[i].koho<>mojecislo then inc(x);
 Pocet_Nepriatelov:=x;
end;

Procedure Defense;
var i,smer:byte;
begin
 for i:=1 to celkovypocetpanakov do begin
  if p^[i].y>1 then p^[i].smer:=hore else
  if p^[i].x>1 then p^[i].smer:=vlavo;
  if v_smere(smer,i) then begin
   if smer=hore then smer:=vpravo else smer:=dole;
  end;
 end;
end;

Function vzd(kto,x,y:byte):real;
begin
 vzd:=abs((p^[kto].x-x))+abs((p^[kto].y-y));
end;



Function Findnearest_Enemy(kto:byte):byte;
var smer1,smer,minx,miny,x,y:byte;
    i:integer;
begin
 minx:={p^[1].x}255;
 miny:={p^[1].y}255;
 for i:=1 to 40 do begin
  if p^[i].koho<>mojecislo then begin
   x:=p^[i].x;
   y:=p^[i].y;
   if vzd(kto,x,y)<vzd(kto,minx,miny) then begin
    minx:=x;
    miny:=y;
   end;
  end;
 end;
 if pole_mojich[kto]=0 then begin
  if (minx<p^[kto].x)  then smer:=vlavo;
  if (minx>p^[kto].x)  then smer:=vpravo;
  if minx=p^[kto].x then begin
   if miny<p^[kto].y then smer:=hore;
   if miny>p^[kto].y then smer:=dole;
  end;
 end else smer:=pole_mojich[kto];
 if (smer=hore) and (p^[kto].y=1) then smer:=0;
 if (smer=dole) and (p^[kto].y=32 )then smer:=0;
 if (smer=vpravo) and (p^[kto].x=32) then smer:=0;
 if (smer=vlavo) and (p^[kto].x=1) then smer:=0;
 if v_smere(smer,kto) then begin
  smer1:=smer;
  if (smer=hore) or (smer=dole) then begin
   if (minx<p^[kto].x)  then smer:=vlavo;
   if (minx>p^[kto].x)  then smer:=vpravo;
   if (minx=p^[kto].x) then if p^[kto].x>1 then smer:=vlavo else smer:=vpravo;
  end else begin
   if miny<p^[kto].y then smer:=hore;
   if miny>p^[kto].y then smer:=dole;
   if miny=p^[kto].y then if p^[kto].y>1 then smer:=hore else smer:=dole;
  end;
  pole_mojich[kto]:=smer1;
 end else pole_mojich[kto]:=0;
 findnearest_enemy:=smer;
end;

procedure chod(i,j:byte);
var a:byte;
begin
 for a:=1 to 40 do begin
   if p^[a].x>i then p^[i].smer:=dole else p^[i].smer:=hore;
   if p^[a].y>j then p^[i].smer:=hore else p^[i].smer:=dole;
 end;
end;

procedure vyfarbuj;
var i,j:integer;
begin
 for i:=1 to 32 do begin
  for j:=1 to 32 do begin
   if (m^[i,j]<>mojecislo) and (m^[i,j]<>mojecislo+5) then begin
    chod(i,j);
   end;
  end;
 end;
end;


Function Panaci_jedneho:byte;
begin
 panaci_jedneho:=1;
end;

procedure tahaj(var panaci:typePanaci; ihrisko:typeIhrisko);

var
 i:integer;

begin
 p:=@panaci;
 m:=@ihrisko;
 x:=pocet_nepriatelov;
 if x=0 then vyfarbuj  else begin
 if panaci_jedneho>25 then defense else
 for i:=1 to celkovypocetpanakov do if p^[i].koho=mojecislo then
  panaci[i].smer:=findnearest_enemy(i);
 end;

end;

procedure hlaska(var subor,text:string);
const hlasky:array[1..7] of string=('krbrutus.wav','kroook.wav','krnic.wav','krtuc.wav','krchaos.wav',
              'krstary.wav','krhaha.wav');

var i:integer;
begin
 i:=random(7)+1;
 begin
  subor:=hlasky[i];
  text:='CPUs  hlasi...';
 end;
end;

End.
